#include <dlfcn.h>
#include <stdio.h>

#include "map.hh"

Map *LoadMap(const char *fn)
{
    void *h = dlopen(fn, RTLD_LAZY);
    if(!h)
    {
    	fprintf(stderr, "%s\n", dlerror());
    	return NULL;
    }
    
    Map *(*buildfun) () = (Map *(*)())dlsym(h, "build");
    if(!buildfun) { fprintf(stderr, "%s\n", dlerror()); dlclose(h); return NULL; }
    Map *m = buildfun();
    
    dlclose(h);
    return m;
}

#if 0
Map *BuildMap(const v3 *verts, unsigned vcount,
              const wall *walls, unsigned wcount)
{
    Map *tmp = new Map();
    tmp->Load(verts, vcount, walls, wcount);
    return tmp;
}
#endif
